## faust2pd-2.16.tar.gz

=== Makefile ===

# Package name and version number:
dist = faust2pd-$(version)
version = 2.16

# Default installation prefix:
prefix = /usr/local

# Try to guess the Pd installation prefix:
pdprefix = $(patsubst %/bin/pd,%,$(shell which pd 2>/dev/null))
ifeq ($(strip $(pdprefix)),)
# Fall back to /usr/local.
pdprefix = /usr/local
endif

bindir = $(prefix)/bin
# where to install the Pd stuff
libdir = $(pdprefix)/lib
datadir = $(libdir)/pd/extra

# Try to guess the host system type and do platform-specific setup.
host = $(shell ./config.guess)
ifneq "$(findstring -mingw,$(host))" ""
# Windows
EXE = .exe
endif
ifneq "$(findstring x86_64-,$(host))" ""
# 64 bit, needs -fPIC flag
PIC = -fPIC
endif

DESTDIR=

DISTFILES = Makefile COPYING ChangeLog README config.guess *.pure *.pd examples/README debian/* examples/*/Makefile examples/*/*.cpp examples/*/*.dsp examples/*/*.syn examples/*/*.pd examples/*/*.pure examples/*/*.xml pd/*.h
SEDFILES = README

.PHONY: all examples clean distclean realclean install uninstall

all: faust2pd$(EXE)

examples: faust2pd$(EXE)
	for x in basic faust synth seqdemo; do $(MAKE) -C examples/$$x all; done

clean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do $(MAKE) -C examples/$$x clean; done

distclean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do $(MAKE) -C examples/$$x distclean; done

realclean:
	rm -f faust2pd$(EXE)
	for x in basic faust synth seqdemo; do $(MAKE) -C examples/$$x realclean; done

# as of pure-0.21, we can compile the script to an executable
faust2pd$(EXE): faust2pd.pure faustxml.pure
	sed -e 's?@version@?$(version)?' < $< > xx$<
	pure $(PIC) $(PUREC_FLAGS) -I. -c xx$< -o $@
	rm -f xx$<

# install faust2pd
install:
	test -d $(DESTDIR)$(bindir) || mkdir -p $(DESTDIR)$(bindir)
	cp faust2pd$(EXE) $(DESTDIR)$(bindir)
	strip $(DESTDIR)$(bindir)/faust2pd$(EXE)
ifeq "$(findstring -mingw,$(host))" ""
	chmod a+x $(DESTDIR)$(bindir)/faust2pd$(EXE)
endif
	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"
	@echo "Optionally, you can also run make install-pd to install the auxiliary Faust"
	@echo "abstractions in $(DESTDIR)$(datadir)."
	@echo "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++"

# install the auxiliary Faust abstractions (faust-*.pd)
install-pd:
	test -d $(DESTDIR)$(datadir) || mkdir -p $(DESTDIR)$(datadir)
	cp faust-*.pd $(DESTDIR)$(datadir)

#uninstall
uninstall:
	rm -rf $(DESTDIR)$(bindir)/faust2pd$(EXE)
	rm -f $(DESTDIR)$(datadir)/faust-*.pd

.PHONY: dist distcheck

# roll distribution tarball

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	mkdir $(dist) && mkdir $(dist)/debian && mkdir $(dist)/pd && mkdir $(dist)/examples
	for x in basic faust seqdemo synth; do mkdir $(dist)/examples/$$x; done
	for x in $(DISTFILES); do ln -sf $$PWD/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,$$PWD/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make all examples && make install install-pd DESTDIR=./BUILD
	rm -rf $(dist)

# Debian packaging

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

# Generate the documentation.

sources = faustxml.pure

faust2pd.txt: README $(sources)
	pure-doc $(sources) | cat README - > $@

=== examples/synth/Makefile ===

# Generic Makefile for Faust Pd plugins.
# Translates ordinary effects (.dsp) and synths (.syn => -n 8).

# make, make all: make plugins and wrappers
# make cpp: make C++ sources
# make svg: make SVG diagrams
# make clean: remove all generated stuff

DLL = .pd_linux
shared = -shared

# Try to guess the host system type and figure out platform specifics.
host = $(shell ../../config.guess)
ifneq "$(findstring -mingw,$(host))" ""
# Windows
DLL = .dll
PDLIB = -Wl,--enable-auto-import -lpd
endif
ifneq "$(findstring -darwin,$(host))" ""
# OSX
DLL = .pd_darwin
shared = -dynamiclib -Wl,-undefined -Wl,dynamic_lookup
endif
ifneq "$(findstring x86_64-,$(host))" ""
# 64 bit, needs -fPIC flag
EXTRA_CFLAGS += -fPIC
endif
ifneq "$(findstring x86,$(host))" ""
# architecture-specific options for x86 and x86_64
EXTRA_CFLAGS += -msse -ffast-math
endif

EXTRA_CFLAGS += -I ../../pd

# Define the desired number of voices for synth (.syn) plugins here:
NVOICES = 8

dspsrc  := $(wildcard *.dsp)
synsrc  := $(wildcard *.syn)
cppsrc  := $(dspsrc:.dsp=.cpp) $(synsrc:.syn=.cpp)
plugins	:= $(dspsrc:%.dsp=%~$(DLL)) $(synsrc:%.syn=%~$(DLL))
svg 	:= $(dspsrc:.dsp=.dsp-svg) $(synsrc:.syn=.syn-svg)
xml 	:= $(dspsrc:.dsp=.dsp.xml) $(synsrc:.syn=.syn.xml)
pd 	:= $(dspsrc:.dsp=.pd) $(synsrc:.syn=.pd)

#faust2pd = faust2pd
faust2pd = ../../faust2pd

#all: $(plugins) $(svg) $(pd)
all: $(plugins) $(pd)
cpp: $(cppsrc)
svg: $(svg)
xml: $(xml)
pd:  $(pd)

clean:
	rm -Rf *~ $(plugins)

distclean: clean
	rm -f $(cppsrc)

realclean: distclean
	rm -Rf $(svg) $(xml) $(pd)

%.dsp-svg: %.dsp
	faust -svg $< -o /dev/null >/dev/null

%.syn-svg: %.syn
	faust -svg $< -o /dev/null >/dev/null

%.cpp: %.dsp
	faust $(VEC) -a puredata.cpp $< -o $@

%.cpp: %.syn
	faust $(VEC) -a puredata.cpp $< -o $@

%.dsp.xml: %.dsp
	faust -xml $< -o /dev/null

%.syn.xml: %.syn
	faust -xml $< -o /dev/null

%~$(DLL): %.cpp
	$(CXX) $(shared) $(EXTRA_CFLAGS) $(CFLAGS) -Dmydsp=$(@:%~$(DLL)=%) $< -o $@ $(PDLIB)

%.pd: %.dsp.xml
	$(faust2pd) -s $<

%.pd: %.syn.xml
	$(faust2pd) -n $(NVOICES) -s $<

=== debian/changelog ===
faust2pd (2.15-2) xenial; urgency=medium

  * Missing -fPIC flag (batch compilation)

 -- Albert Graef <aggraef@gmail.com>  Mon, 09 Jan 2017 09:26:36 +0100

faust2pd (2.15-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sun, 01 Jan 2017 11:58:17 +0100

faust2pd (2.13-1) xenial; urgency=medium

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 05 Jul 2016 21:06:22 +0200

faust2pd (2.12-2) xenial; urgency=medium

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Sun, 05 Jun 2016 20:10:46 +0200

faust2pd (2.12-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 06 Nov 2014 18:22:14 +0100

faust2pd (2.11-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 04 Nov 2014 01:21:04 +0100

faust2pd (2.10-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 04 Nov 2014 00:06:37 +0100

faust2pd (2.9-2) trusty; urgency=low

  * Latest upstream fixes

 -- Albert Graef <aggraef@gmail.com>  Tue, 28 Oct 2014 23:55:07 +0100

faust2pd (2.9-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Tue, 23 Sep 2014 07:04:59 +0200

faust2pd (2.8-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 17 Sep 2014 00:31:36 +0200

faust2pd (2.7-2) trusty; urgency=low

  * Pass the -mcpu=generic option to llc when batch-compiling Pure
    scripts, to prevent illegal instructions depending on the build host's
    cpu type.

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 09:53:18 +0200

faust2pd (2.7-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 13 Sep 2014 23:08:45 +0200

faust2pd (2.5-3) natty; urgency=low

  * Dependency fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 01:00:28 +0200

faust2pd (2.5-2) natty; urgency=low

  * Add missing build dependency llvm

 -- Albert Graef <Dr.Graef@t-online.de>  Fri, 25 May 2012 07:46:14 +0200

faust2pd (2.5-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 21:36:49 +0200

=== debian/control ===
Source: faust2pd
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure, pure-dev, pure-xml, puredata, faust|faust2
Standards-Version: 3.9.5
Homepage: http://purelang.bitbucket.org

Package: faust2pd
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, pure-xml
Description: Generate Pd GUI abstractions from Faust programs
 faust2pd is a little utility to generate "graph-on-parent" GUI abstractions
 from programs written in Faust, Grame's functional signal processing
 language. This makes it easier to use Faust signal processing units with
 Miller Puckette's Pure Data (Pd).

Package: faust2pd-extra
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Generate Pd GUI abstractions from Faust programs
 faust2pd is a little utility to generate "graph-on-parent" GUI abstractions
 from programs written in Faust, Grame's functional signal processing
 language. This makes it easier to use Faust signal processing units with
 Miller Puckette's Pure Data (Pd).
 .
 This package contains some helper abstractions to be used with Pd, and a
 collection of faust2pd examples.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ 

override_dh_auto_build:
	dh_auto_build -- prefix=/usr PUREC_FLAGS=-mcpu=generic all examples

override_dh_auto_install:
	dh_auto_install -- prefix=/usr install-pd
